unit Hauptfenster;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ToolWin, ComCtrls, Struktteile, FlussDiagfenster, Menus, Printers,
  Buttons, Clipbrd;

type
  TForm2 = class(TForm)
    ToolBar1: TToolBar;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Struktogrammladen1: TMenuItem;
    Struktogrammspeichern1: TMenuItem;
    N1: TMenuItem;
    Programmbeenden1: TMenuItem;
    Drucken1: TMenuItem;
    Blockvergrern1: TMenuItem;
    BlockinneuemFensteranzeigen1: TMenuItem;
    Drucken2: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    PrintDialog1: TPrintDialog;
    BAnweisung: TBitBtn;
    BIfAnweisung: TBitBtn;
    Einfgen1: TMenuItem;
    Anweisung: TMenuItem;
    IfAnweisung: TMenuItem;
    WhileSchleife: TMenuItem;
    DoWhileSchleife: TMenuItem;
    ForSchleife: TMenuItem;
    N3: TMenuItem;
    RepeatUntilSchleife: TMenuItem;
    BWhileSchleife: TBitBtn;
    BDoWhileSchleife: TBitBtn;
    BRepeatUntilSchleife2: TBitBtn;
    BRepeatUntilSchleife: TBitBtn;
    BForSchleife: TBitBtn;
    N11: TMenuItem;
    Exportieren1: TMenuItem;
    Neu1: TMenuItem;
    N2: TMenuItem;
    Rckgngig1: TMenuItem;
    N4: TMenuItem;
    InZwischenablage1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonClick(Sender: TObject);
    procedure Struktogrammladen1Click(Sender: TObject);
    procedure Struktogrammspeichern1Click(Sender: TObject);
    procedure Programmbeenden1Click(Sender: TObject);
    procedure Drucken2Click(Sender: TObject);
    procedure Blockvergrern1Click(Sender: TObject);
    procedure BlockinneuemFensteranzeigen1Click(Sender: TObject);
    procedure Exportieren1Click(Sender: TObject);
    procedure Neu1Click(Sender: TObject);
    procedure Rckgngig1Click(Sender: TObject);
    procedure InZwischenablage1Click(Sender: TObject);
  private
    Struktogramm : TElement;
    Kopien: array[0..10] of TElement;
    Akt : integer;
    Widerrufbar : boolean;

    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure RepaintChildren();
    procedure RenameChildren();
    procedure ChangeMinimize(e:TElement);
    procedure SaveKopie();
    procedure DeleteKopie();
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

procedure TForm2.FormCreate(Sender: TObject);
var s : array[0..2] of char;
    c : string;
    f : TFileStream;
begin
  f := nil;

  if ParamCount > 0 then
  begin
    c:= ParamStr(1);
    try
      f:=TFileStream.Create(ParamStr(1),fmOpenRead);
    except
      on e:EFOpenError do
      begin
        MessageDlg(e.message,mtInformation,[mbOk],0);
        f := nil;
      end;
    end;
  end;

  if f <> nil then
  begin
   f.Read(s,2);
   Struktogramm := TBlock.Laden(f);
   f.Free();
  end
  else
    begin
    Struktogramm := TBlock.Create('gesamtes Programm');
  end;
  (Struktogramm as TBlock).ShowBegin:=False;
  (Struktogramm as TBlock).movable := false;
end;

procedure TForm2.FormShow(Sender: TObject);
var t : TForm1;
var i :integer;
begin
  t:=TForm1.CreateWE(self, Struktogramm);
  t.CanClose := false;
  for i:= 1 to 5 do
  begin
    Kopien[i]:= nil;
  end;

  RenameChildren();
end;

procedure TForm2.RepaintChildren();
var i : integer;
begin
  for i := 0 to MDIChildCount -1 do
  begin
    MDIChildren[i].Repaint();
    (MDIChildren[i] as TForm1).AdjustScrollBars();
  end;
end;

procedure TForm2.RenameChildren();
var i : integer;
begin
  for i := 0 to MDIChildCount -1 do
  begin
    MDIChildren[i].Caption := (MDIChildren[i] as TForm1).getTitel;
  end;
end;

procedure TForm2.ChangeMinimize(e:TElement);
var i : integer;
begin
  for i := 0 to MDIChildCount -1 do
  begin
    (MDIChildren[i] as TForm1).ChangeMinimize(e);
  end;
end;


procedure TForm2.ButtonClick(Sender: TObject);
begin
  (ActiveMDIChild as TForm1).Einfuegen(Sender);
end;

procedure TForm2.Struktogrammladen1Click(Sender: TObject);
var i : integer;
    s : array[0..2] of char;
    f : TFileStream;
begin
  OpenDialog1.Filter := 'Struktogramme (*.str)|*.str|Alle Dateien|*.*';
  if OpenDialog1.Execute then
  begin
    Struktogramm.delete(Struktogramm);
    Struktogramm.free;

    f:=TFileStream.Create(OpenDialog1.Filename,fmOpenRead);
    f.Read(s,2);
    Struktogramm := TBlock.Laden(f);
    (Struktogramm as TBlock).movable := false;
    (Struktogramm as TBlock).ShowBegin := false;
    f.Free();

    for i:= 1 to 10 do
    begin
      if Kopien[i]<> nil then
      begin
        Kopien[i].delete(Kopien[i]);
        Kopien[i].free;
        Kopien[i]:= nil;
      end;
    end;

    (MDIChildren[MDIChildCount-1] as TForm1).setStruktogramm(Struktogramm);
    if MDIChildCount>1 then
      for i:= MDIChildCount-2 downto 0 do MDIChildren[i].Close;
  end;
end;


procedure TForm2.Struktogrammspeichern1Click(Sender: TObject);
var f : TFileStream;
begin
  SaveDialog1.Filter := 'Struktogramme (*.str)|*.str|Alle Dateien|*.*';
  SaveDialog1.DefaultExt := 'str';
  if SaveDialog1.Execute then
  begin
    f:=TFileStream.Create(SaveDialog1.Filename,fmCreate);
    Struktogramm.speichern(f);
    f.Free();
  end;
end;

procedure TForm2.Programmbeenden1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm2.Drucken2Click(Sender: TObject);
begin
  if PrintDialog1.Execute then
  begin
    with Printer do
    begin
      Title := ActiveMDIChild.Caption;
      BeginDoc();
      (ActiveMDIChild as TForm1).PrintStruktogramm(canvas);
      EndDoc();
    end;
  end;
end;

procedure TForm2.Blockvergrern1Click(Sender: TObject);
begin
  (ActiveMDIChild as TForm1).ChangeDisplay(Sender);
end;

procedure TForm2.BlockinneuemFensteranzeigen1Click(Sender: TObject);
begin
  (ActiveMDIChild as TForm1).InneuemFensteranzeigen(Sender);
end;

procedure TForm2.Exportieren1Click(Sender: TObject);
var f : TFileStream;
    s : array[0..20000] of char;
begin
  s[0]:=#0;
  SaveDialog1.Filter := 'Quellcode (*.pas)|*.pas|Alle Dateien|*.*';
  SaveDialog1.DefaultExt := 'pas';
  if SaveDialog1.Execute then
  begin
    f:=TFileStream.Create(SaveDialog1.Filename,fmCreate);
    Struktogramm.exportieren(s,'');
    f.writeBuffer(s,strlen(s));
    f.Free();
  end;
end;

procedure TForm2.Neu1Click(Sender: TObject);
var i : integer;
begin
  if MDIChildCount>1 then
    for i:= MDIChildCount-2 downto 0 do MDIChildren[i].Close;

  Struktogramm.delete(Struktogramm);
  Struktogramm.free;

  for i:= 1 to 10 do
  begin
      if Kopien[i]<> nil then
      begin
        Kopien[i].delete(Kopien[i]);
        Kopien[i].free;
        Kopien[i]:= nil;
      end;
  end;

  Struktogramm := TBlock.Create('gesamtes Programm');

  (Struktogramm as TBlock).movable := false;
  (Struktogramm as TBlock).ShowBegin := false;

  (MDIChildren[MDIChildCount-1] as TForm1).setStruktogramm(Struktogramm);
end;

procedure TForm2.Rckgngig1Click(Sender: TObject);
var i : integer;
begin
  if (akt < 10) and (Kopien[akt+1] <> nil) then
  begin
    if MDIChildCount>1 then
      for i:= MDIChildCount-2 downto 0 do MDIChildren[i].Close;

    Struktogramm.delete(Struktogramm);
    Struktogramm.free;

    akt := akt + 1;
    Widerrufbar := true;
    Struktogramm := TBlock.Copy(Kopien[akt]);
    (MDIChildren[MDIChildCount-1] as TForm1).setStruktogramm(Struktogramm);
  end;
end;

procedure TForm2.SaveKopie();
var x : integer;
begin
  while (Akt <> 0) do
  begin
    DeleteKopie();
    Akt := Akt -1;
  end;
  if (Kopien[10]<> nil) then
  begin
    Kopien[10].delete(Kopien[10]);
    Kopien[10].free;
  end;
  for x:= 10 downto 2 do Kopien[x]:=Kopien[x-1];
  Kopien[1] := TBlock.Copy(Struktogramm);
  Widerrufbar := false;
  Akt := 0;
end;

procedure TForm2.DeleteKopie();
var x : integer;
begin
  Kopien[1].delete(Kopien[1]);
  Kopien[1].free;
  for x:= 1 to 9 do Kopien[x]:=Kopien[x+1];
  Kopien[10] := nil;
end;

procedure TForm2.InZwischenablage1Click(Sender: TObject);
var s : array[0..20000] of char;
    cl : TClipboard;
begin
  s[0]:=#0;
  Struktogramm.exportieren(s,'');
  cl := TClipboard.Create;
  cl.clear;
  cl.setTextBuf(s);
end;

end.

